close all; clear all;
foldername='X:\optics_measurement\laser measurements\etalon\DFB\5_11_2016\raw\';
filename='Agilent_trace_';

start=1;
stop=5;
N=stop-start+1;
 T=zeros(N,1);
 E_pos=zeros(N,2);

for n=start:stop;%
 n;

 % convert n to string  
[ths,huns,tens,units]=myNumber(n) ;

% read data file of etalon response, Ch1, and laser sweep, Ch2
measurement_file =[foldername filename ths huns tens units  '.lvm'];%
fid = fopen(measurement_file);% 
HDRS = textscan(fid,'%s %s %s %s',22,'Delimiter',',');%  for lvm file
MEAS = textscan(fid,'%f %f %f %f','Headerlines',22,'Delimiter',',\t');
fclose(fid);
ch1= MEAS{1,2}; % etalon
ch2= MEAS{1,3}; % laser
INFO=HDRS{1,2};
dt=str2num(INFO{20});


% read data file - i.e. get temperature value
data_file=[foldername filename ths huns tens units  '.dat'];%
  
alldata=textread(data_file,'%s', 'delimiter', ',\n=');
T_data=alldata{4,1};
T_num=str2num(T_data);

% % manually choose range of sweep of laser one time
% figure (1)
% subplot(2,1,1)
% plot(ch2)
% X1=floor(length(ch2)/4);
% X2=floor(length(ch2)/2);
% region=ch2(floor(end/4):floor(end/2));
% subplot(2,1,2)
% x=1:length(ch2);
% plot(x(floor(end/4):floor(end/2)),region)
% axis([x(1) x(end) min(region) max(region)])

[laser, l_pks, etalon, e_pks, freq] =myDFB_scan2(ch1,ch2,dt);

figure (1)
subplot(2,1,1)
plot(freq,laser,freq(l_pks),laser(l_pks),'+r')
subplot(2,1,2)
plot(freq,etalon,freq(e_pks),etalon(e_pks),'+r')



freq_e=freq-0.150; % AOM shift
% plot(freq_e,etalon,freq_e(e_pks),etalon(e_pks),'*r')
% title('etalon signal')

% E_pos(n,1:2)=freq(e_pks(1:2));

% position of Rb Lines

Rb87F1F2=6.834-0+0.815;
Rb87F1F2x1=6.834-0.4075+0.815;
Rb87F1F1=6.834-0.815+0.815;
Rb85F2F3=6.834-2.721+0.815;
Rb85F2F3x2=6.834-2.902+0.815;
Rb85F2F2=6.834-3.083+0.815;
Rb85F3F3=6.834-5.756+0.815;
Rb85F3F3x2=6.834-5.937+0.815;
Rb85F3F2=6.834-6.118+0.815;
Rb87F2F2=6.834-6.834+0.815;
Rb87F2F2x1=6.834-7.2415+0.815;
Rb87F2F1=6.834-7.649+0.815;


% match RbD1 to laser peaks
% RbD1=[Rb87F2F1 Rb87F2F2...
%     Rb85F3F2  Rb85F3F3x2 Rb85F3F3...
%     Rb85F2F2  Rb85F2F3x2 Rb85F2F3...
%     Rb87F1F2 ];
% 
% RbD1=[Rb85F3F2  Rb85F3F3x2 Rb85F3F3...
%     Rb85F2F2  Rb85F2F3x2 Rb85F2F3];

RbD1=[Rb85F3F2  Rb85F3F3x2 Rb85F3F3...
     Rb85F2F3x2 Rb85F2F3];
 
%  RbD1=[Rb85F2F3 Rb85F2F3x2    ...
%       Rb85F3F3  Rb85F3F3x2 Rb85F3F2];
%  
 F=1:length(etalon);

 figure (2)
 hold on
%  subplot(2,1,1)
scatter(RbD1,l_pks',25,'b','+')
Q1=polyfit(l_pks',RbD1,1);
freq=Q1(1)*F+Q1(2);
% Q2=polyfit(RbD1',l_pks,2);
% qfit2=Q2(1)*F.^2+Q2(2)*F+Q2(3);
% Q3=polyfit(RbD1',l_pks,3);
% qfit3=Q3(1)*F.^3+Q3(2)*F.^2+Q3(3)*F+Q3(4);
% subplot(2,1,2)
hold on 
% plot(F,qfit1,F,qfit2,F,qfit2,F,qfit3)
% plot(F,qfit1)%,l_pks,'r+');%,F,qfit2,F,qfit2,F,qfit3)
plot(freq,F)

figure(3)

hold on 
 subplot(2,1,1)
plot(freq,laser,freq(l_pks),laser(l_pks),'*r')
title('Cosy signal')

subplot(2,1,2)
hold on 
plot(freq,etalon,freq(e_pks),etalon(e_pks),'*r')
title('etalon signal')
T(n)=T_num;

 E_pos(n,1:2)=freq(e_pks(1:2));
end

T1=min(T)-0.5;
T2=max(T)+0.5;
TT=T1:0.01:T2;
figure (10)

subplot(3,1,2)
scatter(T,E_pos(:,1))
Q2=polyfit(T,E_pos(:,1),1);
et_f1=Q2(1)*TT+Q2(2);
hold on
plot(TT,et_f1,'r')
title([' first etalon peak pk2= ', num2str(Q2(1),5),'*T  +', num2str(Q2(2),5)])
axis([T1 T2 -3 3 ])
subplot(3,1,3)
scatter(T,E_pos(:,2))
Q3=polyfit(T,E_pos(:,2),1);
et_f2=Q3(1)*TT+Q3(2);
hold on
plot(TT,et_f2,'g')
title(['second etalon peak pk1= ', num2str(Q3(1),5),'*T  +', num2str(Q3(2),5)])
ylabel('detuning [GHz]')
xlabel('temperature [K]')
axis([T1 T2 7 13 ])

% add Stokes and Anti Stokes lines
AOM_shift=0.150;
delta_S=Rb85F3F2-Rb87F2F2x1;
F_S=Rb87F1F2+delta_S-AOM_shift
T_S=(F_S-Q3(2))/Q3(1)

delta_AS=Rb87F1F1-Rb85F2F3;
F_AS=Rb87F2F1-delta_AS-AOM_shift
T_AS=(-F_AS-Q2(2))/Q2(1)

figure(10)
subplot(3,1,1)
plot(freq,(laser-min(laser))/(max(laser)-min(laser)))
axis([-5 15 -0.1 1.1])
line([F_AS F_AS],[-0.1 1.1],'Color','b','LineWidth',1.5)
line([F_S F_S],[-0.1 1.1],'Color','k','LineWidth',1.5)
line([Rb85F3F2 Rb85F3F2],[-0.1 1.1],'Color','r','LineWidth',1)
line([Rb87F2F2x1 Rb87F2F2x1],[-0.1 1.1],'Color','y','LineWidth',1)
line([Rb87F1F2 Rb87F1F2],[-0.1 1.1],'Color','g','LineWidth',1)

subplot(3,1,2)
hold on 
line([T_AS T_AS],[-5 5],'Color','b','LineWidth',1.5)

subplot(3,1,3)
hold on 
line([T_S T_S],[0 15],'Color','k','LineWidth',1.5)
% 
% 
% figure (1)
% subplot(2,1,1)
% line(F_S,-2:1e-3:1,'Color','b','LineWidth',1.5)
% line(F_AS,-2:1e-3:1,'Color','r','LineWidth',1.5)
% 
% %     P = polyfit(x,y1,1);
% %     yfit = P(1)*x+P(2);
% %     hold on;
% %     plot(x,yfit,'r-.');
% figure(10)
% subplot(2,1,1)
% scatter(T,E_pos(:,1),25,'b','+')
% P1=polyfit(T,E_pos(:,1),1);
% yfit1= P1(1)*T+P1(2);
% hold on;
% plot(T,yfit1,'r-.');
% TT=min(T):0.001:max(T);
% Y1=Rb87F2F1;%:length(TT):Rb87F2F1;
% Y2=Rb87F1F2;%:length(TT):Rb87F1F2;
% Y3=Rb87F1F1-Rb85F2F3;%:length(TT):Rb87F1F1-Rb85F2F3;
% % line(TT,Y1);
% % line(TT,Y2);
% % line(TT,Y3,'Color','r','LineWidth',1);
% % line(TT,F_S,'Color','b','LineWidth',1.5)
% % line(TT,F_AS,'Color','r','LineWidth',1.5)
% % axis([295.50 296.70 -3 0.1])
% % plot(T,E_pos(:,1),'+b')
% title(['first etalon peak, F = ', num2str(P1(2),3), ' - ',num2str(abs(P1(1)),3), '\times T'])
% 
% 
% subplot(2,1,2)
% scatter(T,E_pos(:,2),25,'b','+')
% P2=polyfit(T,E_pos(:,2),1);
% yfit2= P2(1)*T+P2(2);
% % hold on;
% % plot(T,yfit2,'g-.');
% % line(TT,Y1);
% % hold on
% % line(TT,Y2);
% % hold on
% % line(TT,Y3,'Color','r','LineWidth',1);
% % line(TT,F_S,'Color','b','LineWidth',1.5)
% % line(TT,F_AS,'Color','r','LineWidth',1.5)
% title(['second etalon peak, F = ', num2str(P2(2),3), ' - ',num2str(abs(P2(1)),3), '\times T'])
% 
% ylabel('freq [GHz]')
% xlabel('T [K]')
% % axis([295.50 296.70 7 10.1])
% close (figure(3))
% figure(3)
% s_f=0.01;
% subplot(3,1,1)
% plot(freq,freq*(laser(end)-laser(1))/(freq(end)-freq(1))-laser'-laser(1));%-0.00*n,freq(l_pks),laser(l_pks)-0.00*n,'*r')
% hold on
% % freq_e=freq-0.150; % AOM shift
% plot(freq,etalon*s_f);%,freq_e(e_pks),etalon(e_pks),'*r')
% 
% line(F_S,-2:1e-3:1,'Color','b','LineWidth',1.5)
% line(F_AS,-2:1e-3:1,'Color','r','LineWidth',1.5)
% % axis([-4 12 -0.01 0.1])
% 
% subplot(3,1,2)
% scatter(T,E_pos(:,1),25,'b','+')
% hold on;
% plot(T,yfit1,'r-.');
% 
% subplot(3,1,3)
% scatter(T,E_pos(:,2),25,'b','+')
% hold on;
% plot(T,yfit2,'r-.');